
//+------------------------------------------------------------------+
//|                                                        Marza.mq4 |
//|                                Copyright  2006,  Matist Krusoe. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006,  Matist Krusoe."
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow

//---- buffers
double equity[];
//---- parameters

///  
double dep=0;
extern int plecho = 100;

///  
double lots[12];
///  
string simb[12];
///  
double opprice[12];
///        
double mlots[12];
///         
double pipweight[12];
///  
double profitpip[12];
double profloss=0;
double summamarz=0;


extern string simb_01 = "EURUSD";
extern double openprice_01 = 1.2965;
extern double lots_01 = -1.0;

extern string simb_02 = "GBPUSD";
extern double openprice_02 = 1.9010;
extern double lots_02 = -1.0;

extern string simb_03 = "NZDUSD";
extern double openprice_03 = 0.672;
extern double lots_03 = -1.0;

extern string simb_04 = "GBPCHF";
extern double openprice_04 = 2.3735;
extern double lots_04 = -1.0;

extern string simb_05 = "USDJPY";
extern double openprice_05 = 144.90;
extern double lots_05 = -0.1;

extern string simb_06 = "";
extern double openprice_06 = 0;
extern double lots_06 = 0;

extern string simb_07 = "";
extern double openprice_07 = 0;
extern double lots_07 = 0;

extern string simb_08 = "";
extern double openprice_08 = 0;
extern double lots_08 = 0;

extern string simb_09 = "";
extern double openprice_09 = 0;
extern double lots_09 = 0;

extern string simb_10 = "";
extern double openprice_10 = 0;
extern double lots_10 = 0;

extern string simb_11 = "";
extern double openprice_11 = 0;
extern double lots_11 = 0;

extern string simb_12 = "";
extern double openprice_12 = 0;
extern double lots_12 = 0;

extern double mar_01 = 0;
extern double mar_02 = 0;
extern double mar_03 = 0;
extern double mar_04 = 0;
extern double mar_05 = 0;
extern double mar_06 = 0;
extern double mar_07 = 0;
extern double mar_08 = 0;
extern double mar_09 = 0;
extern double mar_10 = 0;
extern double mar_11 = 0;
extern double mar_12 = 0; 

int init()
  {
///  
   lots[0] = lots_01;
   lots[1] = lots_02;
   lots[2] = lots_03;
   lots[3] = lots_04;
   lots[4] = lots_05;
   lots[5] = lots_06;
   lots[6] = lots_07;
   lots[7] = lots_08;
   lots[8] = lots_09;
   lots[9] = lots_10;
   lots[10] = lots_11;
   lots[11] = lots_12;

///  
   simb[0] = simb_01;
   simb[1] = simb_02;
   simb[2] = simb_03;
   simb[3] = simb_04;
   simb[4] = simb_05;
   simb[5] = simb_06;
   simb[6] = simb_07;
   simb[7] = simb_08;
   simb[8] = simb_09;
   simb[9] = simb_10;
   simb[10] = simb_11;
   simb[11] = simb_12;

///  
   opprice[0] = openprice_01;
   opprice[1] = openprice_02;
   opprice[2] = openprice_03;
   opprice[3] = openprice_04;
   opprice[4] = openprice_05;
   opprice[5] = openprice_06;
   opprice[6] = openprice_07;
   opprice[7] = openprice_08;
   opprice[8] = openprice_09;
   opprice[9] = openprice_10;
   opprice[10] = openprice_11;
   opprice[11] = openprice_12;

///  
   mlots[0] = mar_01;
   mlots[1] = mar_02;
   mlots[2] = mar_03;
   mlots[3] = mar_04;
   mlots[4] = mar_05;
   mlots[5] = mar_06;
   mlots[6] = mar_07;
   mlots[7] = mar_08;
   mlots[8] = mar_09;
   mlots[9] = mar_10;
   mlots[10] = mar_11;
   mlots[11] = mar_12;
//---- indicator
   SetIndexStyle(0, DRAW_LINE);
   SetIndexLabel(0, "equity%");
   SetIndexBuffer(0, equity); 
/// ---> 
   for(int ml=0; ml<12; ml++){
      if (simb[ml]!="") {
         ///              
         if (mlots[ml]<1) mlots[ml] = MarketInfo(simb[ml], MODE_LOTSIZE)/plecho;//LotMargin(simb[ml],lots[ml]); 
         ///         
         pipweight[ml] = MarketInfo(simb[ml], MODE_TICKVALUE)*MathAbs(lots[ml]);//MathAbs(lots[ml])*mlots[ml]/plecho;
         dep += MathAbs(lots[ml]*mlots[ml]);
         }      
      }
//--->
   for(int u=0; u<12; u++){
      profitpip[u] = lots[u]/MathAbs(lots[u])*(iClose(simb[u], 0, 0) - opprice[u])*UpDown(iClose(simb[u], 0, 0));
      profloss+=profitpip[u]*pipweight[u];
         if(lots[u]!=0){
            summamarz+=MathAbs(lots[u]*mlots[u]);
            }
      }
//*///--->
   return(0);
  }

void deinit() {
  Comment("");
}

int start()
  {
   int limit;
   int CountedBars=IndicatorCounted();
  //----    
     if(CountedBars<0) return(-1);
         else CountedBars--;
     limit=Bars-CountedBars;
//--->   
   string comm[12];
   int icom=0; 
   
   for(int p=0; p<11; p++)
      if(lots[p]!=0){
         comm[p] = simb[p]+" ( "+ DoubleToStr(lots[p],1)+" lots, "+DoubleToStr(MathAbs(lots[p]*mlots[p]),2) +"$ ) " + DoubleToStr(profitpip[p]*pipweight[p],2) + "$ (" + DoubleToStr(profitpip[p],0)+"pp, " + DoubleToStr(pipweight[p],2) + "$ ); ";
         icom++;
         if (icom>1){
            comm[p]=comm[p]+"\n";
            icom = 0;
         }
      }
      else
         comm[p] = "";
   
   Comment( comm[0], comm[1], comm[2], comm[3]
         , comm[4], comm[5], comm[6], comm[7]
         , comm[8], comm[9], comm[10], comm[11]
         , "\n :   " + DoubleToStr(dep,2) + "   /:   " + DoubleToStr(profloss,2)
         , "\n  :   " + DoubleToStr(summamarz,2)
         , "\n  :   " + DoubleToStr(FreeMarza(0),2)
         );
//--->
   if(summamarz!=0)
      for(int i=0; i<limit; i++){
         equity[i] = (FreeMarza(i)/summamarz*100);
         }   
   string indname = " " + DoubleToStr(summamarz,2) + "$   / " + DoubleToStr(FreeMarza(0),2) + "$   % " + DoubleToStr(equity[0],2)+"%  ";
   IndicatorShortName(indname);
   return(0);
}

double FreeMarza(int i){
   double summ=0;  
   for(int q=0; q<12; q++)
      if(lots[q]!=0)
         summ+=lots[q]/MathAbs(lots[q])*(iClose(simb[q], 0, i) - opprice[q])*UpDown(iClose(simb[q], 0, i))*pipweight[q];
   return(summ);   
}   

double UpDown(double a){
   if (a<10) return (10000);
      else return (100);
} 
/*
double LotMargin(string sy, double lo, int nb=0) { /// () KimIV "http://www.kimiv.ru"
  int    al=AccountLeverage();
  double dg=MarketInfo(sy, MODE_DIGITS);
  double ls=MarketInfo(sy, MODE_LOTSIZE);
  double pc=MathPow(10, dg-4);
  double ts=MarketInfo(sy, MODE_TICKSIZE);
  double tv=MarketInfo(sy, MODE_TICKVALUE);

  return(lo*MathCeil(ls/1000000)*100000*iClose(sy,0,nb)*(tv*pc)*(ts*pc)*al*0.1);
}
*/